'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Select = require('./Select');

var _Select2 = _interopRequireDefault(_Select);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _parseUnit = require('parse-unit');

var _parseUnit2 = _interopRequireDefault(_parseUnit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var prepareFamilyWeights = function prepareFamilyWeights() {
  var weights = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var filterOutItalics = arguments[1];

  var newWeights = void 0;

  // Convert regular/italic to 400 / 400italic
  newWeights = weights.map(function (weight) {
    if (weight === 'regular') {
      return '400';
    } else if (weight === 'italic') {
      return '400italic';
    } else {
      return weight;
    }
  });

  // Remove italic options.
  if (filterOutItalics) {
    newWeights = _lodash2.default.filter(newWeights, function (weight) {
      return (0, _parseUnit2.default)(weight)[1] !== 'italic';
    });
  }

  newWeights = _lodash2.default.sortBy(newWeights, function (weight) {
    return (0, _parseUnit2.default)(weight)[0];
  });

  return newWeights;
};

var pickFamilyWeightValue = function pickFamilyWeightValue() {
  var weights = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var weight = arguments[1];
  var filterOutItalics = arguments[2];

  var preparedWeights = prepareFamilyWeights(weights, filterOutItalics);
  return _lodash2.default.indexOf(preparedWeights, weight.toString());
};

var FontWeightTool = function (_React$Component) {
  _inherits(FontWeightTool, _React$Component);

  function FontWeightTool() {
    _classCallCheck(this, FontWeightTool);

    return _possibleConstructorReturn(this, (FontWeightTool.__proto__ || Object.getPrototypeOf(FontWeightTool)).apply(this, arguments));
  }

  _createClass(FontWeightTool, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(_Select2.default, {
        options: prepareFamilyWeights(this.props.family.weights, true),
        value: pickFamilyWeightValue(this.props.family.weights, this.props.weight, true),
        style: {
          width: '100%'
        },
        onChange: function onChange(value) {
          var newOptions = _extends({}, _this2.props.options);
          var weights = prepareFamilyWeights(_this2.props.family.weights, true);

          var newWeight = weights[value];

          // Set new weight.
          if (_this2.props.type === 'header') {
            newOptions.headerWeight = newWeight;
          } else if (_this2.props.type === 'body') {
            newOptions.bodyWeight = newWeight;
          } else if (_this2.props.type === 'bold') {
            newOptions.boldWeight = newWeight;
          }

          // Add weight to Google Fonts array.
          var fontFamily = _lodash2.default.find(newOptions.googleFonts, function (font) {
            return font.name === _this2.props.family.family;
          });
          fontFamily.styles.push(newWeight.toString());

          // Also push italic if this is for body/bold
          if (_this2.props.type === 'body' || _this2.props.type === 'bold') {
            fontFamily.styles.push(newWeight + 'i');
          }

          // Filter out old weight.
          fontFamily.styles = _lodash2.default.filter(fontFamily.styles, function (style) {
            return (0, _parseUnit2.default)(style)[0].toString() !== _this2.props.weight.toString();
          });

          _this2.props.onChange(newOptions);
        }
      });
    }
  }]);

  return FontWeightTool;
}(_react2.default.Component);

exports.default = FontWeightTool;
module.exports = exports['default'];